Index: branches/gsoc10-gui/Pallet/English.lproj/MainMenu.xib
===================================================================
--- branches/gsoc10-gui/Pallet/English.lproj/MainMenu.xib	(revision 68443)
+++ branches/gsoc10-gui/Pallet/English.lproj/MainMenu.xib	(revision 68787)
@@ -13,7 +13,5 @@
 		<object class="NSMutableArray" key="IBDocument.EditedObjectIDs">
 			<bool key="EncodedWithXMLCoder">YES</bool>
-			<integer value="840"/>
-			<integer value="430"/>
-			<integer value="435"/>
+			<integer value="850"/>
 		</object>
 		<object class="NSArray" key="IBDocument.PluginDependencies">
@@ -1375,15 +1373,16 @@
 															<object class="NSMutableArray" key="NSSubviews">
 																<bool key="EncodedWithXMLCoder">YES</bool>
-																<object class="NSRuleEditorViewSliceRow" id="363486199">
+																<object class="NSRuleEditorViewSliceRow" id="156337374">
 																	<reference key="NSNextResponder" ref="887125716"/>
 																	<int key="NSvFlags">290</int>
 																	<object class="NSMutableArray" key="NSSubviews">
 																		<bool key="EncodedWithXMLCoder">YES</bool>
-																		<object class="NSButton" id="227789221">
-																			<reference key="NSNextResponder" ref="363486199"/>
+																		<object class="NSButton" id="624981652">
+																			<reference key="NSNextResponder" ref="156337374"/>
 																			<int key="NSvFlags">257</int>
 																			<string key="NSFrame">{{741, 4}, {18, 18}}</string>
-																			<reference key="NSSuperview" ref="363486199"/>
-																			<reference key="NSNextKeyView" ref="1018513936"/>
+																			<reference key="NSSuperview" ref="156337374"/>
+																			<reference key="NSWindow"/>
+																			<reference key="NSNextKeyView" ref="936953994"/>
 																			<int key="NSTag">-1</int>
 																			<bool key="NSEnabled">YES</bool>
@@ -1413,7 +1412,7 @@
 																					</object>
 																				</object>
-																				<reference key="NSControlView" ref="227789221"/>
+																				<reference key="NSControlView" ref="624981652"/>
 																				<string key="NSAction">_addOption:</string>
-																				<reference key="NSTarget" ref="363486199"/>
+																				<reference key="NSTarget" ref="156337374"/>
 																				<int key="NSButtonFlags">-2038284033</int>
 																				<int key="NSButtonFlags2">36</int>
@@ -1428,10 +1427,11 @@
 																			</object>
 																		</object>
-																		<object class="NSButton" id="49769852">
-																			<reference key="NSNextResponder" ref="363486199"/>
+																		<object class="NSButton" id="891926121">
+																			<reference key="NSNextResponder" ref="156337374"/>
 																			<int key="NSvFlags">257</int>
 																			<string key="NSFrame">{{721, 4}, {18, 18}}</string>
-																			<reference key="NSSuperview" ref="363486199"/>
-																			<reference key="NSNextKeyView" ref="227789221"/>
+																			<reference key="NSSuperview" ref="156337374"/>
+																			<reference key="NSWindow"/>
+																			<reference key="NSNextKeyView" ref="624981652"/>
 																			<int key="NSTag">-1</int>
 																			<bool key="NSEnabled">YES</bool>
@@ -1457,7 +1457,7 @@
 																					</object>
 																				</object>
-																				<reference key="NSControlView" ref="49769852"/>
+																				<reference key="NSControlView" ref="891926121"/>
 																				<string key="NSAction">_deleteOption:</string>
-																				<reference key="NSTarget" ref="363486199"/>
+																				<reference key="NSTarget" ref="156337374"/>
 																				<int key="NSButtonFlags">-2038284033</int>
 																				<int key="NSButtonFlags2">36</int>
@@ -1469,8 +1469,9 @@
 																		</object>
 																		<object class="NSPopUpButton" id="111744215">
-																			<reference key="NSNextResponder" ref="363486199"/>
+																			<reference key="NSNextResponder" ref="156337374"/>
 																			<int key="NSvFlags">256</int>
 																			<string key="NSFrame">{{7, 3}, {58, 19}}</string>
-																			<reference key="NSSuperview" ref="363486199"/>
+																			<reference key="NSSuperview" ref="156337374"/>
+																			<reference key="NSWindow"/>
 																			<reference key="NSNextKeyView" ref="471209054"/>
 																			<int key="NSTag">-1</int>
@@ -1536,9 +1537,10 @@
 																		</object>
 																		<object class="NSPopUpButton" id="471209054">
-																			<reference key="NSNextResponder" ref="363486199"/>
+																			<reference key="NSNextResponder" ref="156337374"/>
 																			<int key="NSvFlags">256</int>
 																			<string key="NSFrame">{{71, 3}, {167, 19}}</string>
-																			<reference key="NSSuperview" ref="363486199"/>
-																			<reference key="NSNextKeyView" ref="49769852"/>
+																			<reference key="NSSuperview" ref="156337374"/>
+																			<reference key="NSWindow"/>
+																			<reference key="NSNextKeyView" ref="891926121"/>
 																			<int key="NSTag">-1</int>
 																			<bool key="NSEnabled">YES</bool>
@@ -1583,4 +1585,5 @@
 																	<string key="NSFrameSize">{769, 25}</string>
 																	<reference key="NSSuperview" ref="887125716"/>
+																	<reference key="NSWindow"/>
 																	<reference key="NSNextKeyView" ref="111744215"/>
 																	<int key="NSRuleRowIndex">0</int>
@@ -1598,5 +1601,5 @@
 																	<object class="NSMutableArray" key="NSRuleOptionItems">
 																		<bool key="EncodedWithXMLCoder">YES</bool>
-																		<object class="NSMutableDictionary" id="1068089292">
+																		<object class="NSMutableDictionary" id="211869200">
 																			<bool key="EncodedWithXMLCoder">YES</bool>
 																			<object class="NSArray" key="dict.sortedKeys">
@@ -1624,5 +1627,5 @@
 																			</object>
 																		</object>
-																		<object class="NSMutableDictionary" id="672539328">
+																		<object class="NSMutableDictionary" id="38677048">
 																			<bool key="EncodedWithXMLCoder">YES</bool>
 																			<object class="NSArray" key="dict.sortedKeys">
@@ -1641,21 +1644,22 @@
 																	<string key="NSRuleOptionInitialFrames.0">{{7, 3}, {58, 19}}</string>
 																	<string key="NSRuleOptionInitialFrames.1">{{71, 3}, {167, 19}}</string>
-																	<reference key="NSRuleOptionAddButton" ref="227789221"/>
-																	<reference key="NSRuleOptionSubtractButton" ref="49769852"/>
+																	<reference key="NSRuleOptionAddButton" ref="624981652"/>
+																	<reference key="NSRuleOptionSubtractButton" ref="891926121"/>
 																	<int key="NSRuleOptionRowType">0</int>
 																	<int key="NSRuleOptionPlusButtonRowType">0</int>
 																	<bool key="NSRuleOptionEditable">YES</bool>
 																</object>
-																<object class="NSRuleEditorViewSliceRow" id="1018513936">
+																<object class="NSRuleEditorViewSliceRow" id="936953994">
 																	<reference key="NSNextResponder" ref="887125716"/>
 																	<int key="NSvFlags">290</int>
 																	<object class="NSMutableArray" key="NSSubviews">
 																		<bool key="EncodedWithXMLCoder">YES</bool>
-																		<object class="NSButton" id="37475490">
-																			<reference key="NSNextResponder" ref="1018513936"/>
+																		<object class="NSButton" id="270724053">
+																			<reference key="NSNextResponder" ref="936953994"/>
 																			<int key="NSvFlags">257</int>
 																			<string key="NSFrame">{{741, 4}, {18, 18}}</string>
-																			<reference key="NSSuperview" ref="1018513936"/>
-																			<reference key="NSNextKeyView" ref="215802558"/>
+																			<reference key="NSSuperview" ref="936953994"/>
+																			<reference key="NSWindow"/>
+																			<reference key="NSNextKeyView" ref="56028161"/>
 																			<int key="NSTag">-1</int>
 																			<bool key="NSEnabled">YES</bool>
@@ -1681,7 +1685,7 @@
 																					</object>
 																				</object>
-																				<reference key="NSControlView" ref="37475490"/>
+																				<reference key="NSControlView" ref="270724053"/>
 																				<string key="NSAction">_addOption:</string>
-																				<reference key="NSTarget" ref="1018513936"/>
+																				<reference key="NSTarget" ref="936953994"/>
 																				<int key="NSButtonFlags">-2038284033</int>
 																				<int key="NSButtonFlags2">36</int>
@@ -1692,10 +1696,11 @@
 																			</object>
 																		</object>
-																		<object class="NSButton" id="874687029">
-																			<reference key="NSNextResponder" ref="1018513936"/>
+																		<object class="NSButton" id="443228088">
+																			<reference key="NSNextResponder" ref="936953994"/>
 																			<int key="NSvFlags">257</int>
 																			<string key="NSFrame">{{721, 4}, {18, 18}}</string>
-																			<reference key="NSSuperview" ref="1018513936"/>
-																			<reference key="NSNextKeyView" ref="37475490"/>
+																			<reference key="NSSuperview" ref="936953994"/>
+																			<reference key="NSWindow"/>
+																			<reference key="NSNextKeyView" ref="270724053"/>
 																			<int key="NSTag">-1</int>
 																			<bool key="NSEnabled">YES</bool>
@@ -1721,7 +1726,7 @@
 																					</object>
 																				</object>
-																				<reference key="NSControlView" ref="874687029"/>
+																				<reference key="NSControlView" ref="443228088"/>
 																				<string key="NSAction">_deleteOption:</string>
-																				<reference key="NSTarget" ref="1018513936"/>
+																				<reference key="NSTarget" ref="936953994"/>
 																				<int key="NSButtonFlags">-2038284033</int>
 																				<int key="NSButtonFlags2">36</int>
@@ -1733,8 +1738,9 @@
 																		</object>
 																		<object class="NSPopUpButton" id="677349919">
-																			<reference key="NSNextResponder" ref="1018513936"/>
+																			<reference key="NSNextResponder" ref="936953994"/>
 																			<int key="NSvFlags">256</int>
 																			<string key="NSFrame">{{37, 3}, {76, 19}}</string>
-																			<reference key="NSSuperview" ref="1018513936"/>
+																			<reference key="NSSuperview" ref="936953994"/>
+																			<reference key="NSWindow"/>
 																			<reference key="NSNextKeyView" ref="855084085"/>
 																			<int key="NSTag">-1</int>
@@ -1816,8 +1822,9 @@
 																		</object>
 																		<object class="NSPopUpButton" id="855084085">
-																			<reference key="NSNextResponder" ref="1018513936"/>
+																			<reference key="NSNextResponder" ref="936953994"/>
 																			<int key="NSvFlags">256</int>
 																			<string key="NSFrame">{{119, 3}, {95, 19}}</string>
-																			<reference key="NSSuperview" ref="1018513936"/>
+																			<reference key="NSSuperview" ref="936953994"/>
+																			<reference key="NSWindow"/>
 																			<reference key="NSNextKeyView" ref="309287992"/>
 																			<int key="NSTag">-1</int>
@@ -1911,9 +1918,10 @@
 																		</object>
 																		<object class="NSTextField" id="309287992">
-																			<reference key="NSNextResponder" ref="1018513936"/>
+																			<reference key="NSNextResponder" ref="936953994"/>
 																			<int key="NSvFlags">256</int>
 																			<string key="NSFrame">{{220, 4}, {61, 18}}</string>
-																			<reference key="NSSuperview" ref="1018513936"/>
-																			<reference key="NSNextKeyView" ref="874687029"/>
+																			<reference key="NSSuperview" ref="936953994"/>
+																			<reference key="NSWindow"/>
+																			<reference key="NSNextKeyView" ref="443228088"/>
 																			<bool key="NSEnabled">YES</bool>
 																			<object class="NSTextFieldCell" key="NSCell">
@@ -1931,4 +1939,5 @@
 																	<string key="NSFrame">{{0, 25}, {769, 25}}</string>
 																	<reference key="NSSuperview" ref="887125716"/>
+																	<reference key="NSWindow"/>
 																	<reference key="NSNextKeyView" ref="677349919"/>
 																	<int key="NSRuleRowIndex">1</int>
@@ -1948,5 +1957,5 @@
 																	<object class="NSMutableArray" key="NSRuleOptionItems">
 																		<bool key="EncodedWithXMLCoder">YES</bool>
-																		<object class="NSMutableDictionary" id="880775721">
+																		<object class="NSMutableDictionary" id="173485813">
 																			<bool key="EncodedWithXMLCoder">YES</bool>
 																			<object class="NSArray" key="dict.sortedKeys">
@@ -1975,5 +1984,5 @@
 																			</object>
 																		</object>
-																		<object class="NSMutableDictionary" id="17599908">
+																		<object class="NSMutableDictionary" id="375500148">
 																			<bool key="EncodedWithXMLCoder">YES</bool>
 																			<object class="NSArray" key="dict.sortedKeys">
@@ -1988,5 +1997,5 @@
 																			</object>
 																		</object>
-																		<object class="NSMutableDictionary" id="729925139">
+																		<object class="NSMutableDictionary" id="293689974">
 																			<bool key="EncodedWithXMLCoder">YES</bool>
 																			<object class="NSArray" key="dict.sortedKeys">
@@ -2006,20 +2015,21 @@
 																	<string key="NSRuleOptionInitialFrames.1">{{119, 3}, {95, 19}}</string>
 																	<string key="NSRuleOptionInitialFrames.2">{{220, 4}, {61, 18}}</string>
-																	<reference key="NSRuleOptionAddButton" ref="37475490"/>
-																	<reference key="NSRuleOptionSubtractButton" ref="874687029"/>
+																	<reference key="NSRuleOptionAddButton" ref="270724053"/>
+																	<reference key="NSRuleOptionSubtractButton" ref="443228088"/>
 																	<int key="NSRuleOptionRowType">0</int>
 																	<int key="NSRuleOptionPlusButtonRowType">0</int>
 																	<bool key="NSRuleOptionEditable">YES</bool>
 																</object>
-																<object class="NSRuleEditorViewSliceRow" id="215802558">
+																<object class="NSRuleEditorViewSliceRow" id="56028161">
 																	<reference key="NSNextResponder" ref="887125716"/>
 																	<int key="NSvFlags">290</int>
 																	<object class="NSMutableArray" key="NSSubviews">
 																		<bool key="EncodedWithXMLCoder">YES</bool>
-																		<object class="NSButton" id="916286195">
-																			<reference key="NSNextResponder" ref="215802558"/>
+																		<object class="NSButton" id="853253325">
+																			<reference key="NSNextResponder" ref="56028161"/>
 																			<int key="NSvFlags">257</int>
 																			<string key="NSFrame">{{741, 4}, {18, 18}}</string>
-																			<reference key="NSSuperview" ref="215802558"/>
+																			<reference key="NSSuperview" ref="56028161"/>
+																			<reference key="NSWindow"/>
 																			<reference key="NSNextKeyView" ref="872100568"/>
 																			<int key="NSTag">-1</int>
@@ -2046,7 +2056,7 @@
 																					</object>
 																				</object>
-																				<reference key="NSControlView" ref="916286195"/>
+																				<reference key="NSControlView" ref="853253325"/>
 																				<string key="NSAction">_addOption:</string>
-																				<reference key="NSTarget" ref="215802558"/>
+																				<reference key="NSTarget" ref="56028161"/>
 																				<int key="NSButtonFlags">-2038284033</int>
 																				<int key="NSButtonFlags2">36</int>
@@ -2057,10 +2067,11 @@
 																			</object>
 																		</object>
-																		<object class="NSButton" id="502111979">
-																			<reference key="NSNextResponder" ref="215802558"/>
+																		<object class="NSButton" id="282999969">
+																			<reference key="NSNextResponder" ref="56028161"/>
 																			<int key="NSvFlags">257</int>
 																			<string key="NSFrame">{{721, 4}, {18, 18}}</string>
-																			<reference key="NSSuperview" ref="215802558"/>
-																			<reference key="NSNextKeyView" ref="916286195"/>
+																			<reference key="NSSuperview" ref="56028161"/>
+																			<reference key="NSWindow"/>
+																			<reference key="NSNextKeyView" ref="853253325"/>
 																			<int key="NSTag">-1</int>
 																			<bool key="NSEnabled">YES</bool>
@@ -2086,7 +2097,7 @@
 																					</object>
 																				</object>
-																				<reference key="NSControlView" ref="502111979"/>
+																				<reference key="NSControlView" ref="282999969"/>
 																				<string key="NSAction">_deleteOption:</string>
-																				<reference key="NSTarget" ref="215802558"/>
+																				<reference key="NSTarget" ref="56028161"/>
 																				<int key="NSButtonFlags">-2038284033</int>
 																				<int key="NSButtonFlags2">36</int>
@@ -2098,8 +2109,9 @@
 																		</object>
 																		<object class="NSPopUpButton" id="974900885">
-																			<reference key="NSNextResponder" ref="215802558"/>
+																			<reference key="NSNextResponder" ref="56028161"/>
 																			<int key="NSvFlags">256</int>
 																			<string key="NSFrame">{{37, 3}, {64, 19}}</string>
-																			<reference key="NSSuperview" ref="215802558"/>
+																			<reference key="NSSuperview" ref="56028161"/>
+																			<reference key="NSWindow"/>
 																			<reference key="NSNextKeyView" ref="207821348"/>
 																			<int key="NSTag">-1</int>
@@ -2156,8 +2168,9 @@
 																		</object>
 																		<object class="NSPopUpButton" id="207821348">
-																			<reference key="NSNextResponder" ref="215802558"/>
+																			<reference key="NSNextResponder" ref="56028161"/>
 																			<int key="NSvFlags">256</int>
 																			<string key="NSFrame">{{107, 3}, {46, 19}}</string>
-																			<reference key="NSSuperview" ref="215802558"/>
+																			<reference key="NSSuperview" ref="56028161"/>
+																			<reference key="NSWindow"/>
 																			<reference key="NSNextKeyView" ref="11724982"/>
 																			<int key="NSTag">-1</int>
@@ -2203,9 +2216,10 @@
 																		</object>
 																		<object class="NSPopUpButton" id="11724982">
-																			<reference key="NSNextResponder" ref="215802558"/>
+																			<reference key="NSNextResponder" ref="56028161"/>
 																			<int key="NSvFlags">256</int>
 																			<string key="NSFrame">{{159, 3}, {155, 19}}</string>
-																			<reference key="NSSuperview" ref="215802558"/>
-																			<reference key="NSNextKeyView" ref="502111979"/>
+																			<reference key="NSSuperview" ref="56028161"/>
+																			<reference key="NSWindow"/>
+																			<reference key="NSNextKeyView" ref="282999969"/>
 																			<int key="NSTag">-1</int>
 																			<bool key="NSEnabled">YES</bool>
@@ -2300,4 +2314,5 @@
 																	<string key="NSFrame">{{0, 50}, {769, 25}}</string>
 																	<reference key="NSSuperview" ref="887125716"/>
+																	<reference key="NSWindow"/>
 																	<reference key="NSNextKeyView" ref="974900885"/>
 																	<int key="NSRuleRowIndex">2</int>
@@ -2317,5 +2332,5 @@
 																	<object class="NSMutableArray" key="NSRuleOptionItems">
 																		<bool key="EncodedWithXMLCoder">YES</bool>
-																		<object class="NSMutableDictionary" id="539965909">
+																		<object class="NSMutableDictionary" id="998086679">
 																			<bool key="EncodedWithXMLCoder">YES</bool>
 																			<object class="NSArray" key="dict.sortedKeys">
@@ -2344,5 +2359,5 @@
 																			</object>
 																		</object>
-																		<object class="NSMutableDictionary" id="635329650">
+																		<object class="NSMutableDictionary" id="699004508">
 																			<bool key="EncodedWithXMLCoder">YES</bool>
 																			<object class="NSArray" key="dict.sortedKeys">
@@ -2357,5 +2372,5 @@
 																			</object>
 																		</object>
-																		<object class="NSMutableDictionary" id="773622241">
+																		<object class="NSMutableDictionary" id="30477181">
 																			<bool key="EncodedWithXMLCoder">YES</bool>
 																			<object class="NSArray" key="dict.sortedKeys">
@@ -2375,6 +2390,6 @@
 																	<string key="NSRuleOptionInitialFrames.1">{{107, 3}, {46, 19}}</string>
 																	<string key="NSRuleOptionInitialFrames.2">{{159, 3}, {155, 19}}</string>
-																	<reference key="NSRuleOptionAddButton" ref="916286195"/>
-																	<reference key="NSRuleOptionSubtractButton" ref="502111979"/>
+																	<reference key="NSRuleOptionAddButton" ref="853253325"/>
+																	<reference key="NSRuleOptionSubtractButton" ref="282999969"/>
 																	<int key="NSRuleOptionRowType">0</int>
 																	<int key="NSRuleOptionPlusButtonRowType">0</int>
@@ -2384,5 +2399,6 @@
 															<string key="NSFrame">{{1, 1}, {769, 73}}</string>
 															<reference key="NSSuperview" ref="872100568"/>
-															<reference key="NSNextKeyView" ref="363486199"/>
+															<reference key="NSWindow"/>
+															<reference key="NSNextKeyView" ref="156337374"/>
 														</object>
 													</object>
@@ -2396,4 +2412,5 @@
 													<string key="NSFrameSize">{771, 75}</string>
 													<reference key="NSSuperview" ref="646625812"/>
+													<reference key="NSWindow"/>
 													<reference key="NSNextKeyView" ref="887125716"/>
 													<bool key="NSEnabled">YES</bool>
@@ -2428,6 +2445,6 @@
 																	<object class="NSMutableArray">
 																		<bool key="EncodedWithXMLCoder">YES</bool>
-																		<reference ref="1068089292"/>
-																		<reference ref="672539328"/>
+																		<reference ref="211869200"/>
+																		<reference ref="38677048"/>
 																	</object>
 																	<object class="NSMutableArray">
@@ -2452,7 +2469,7 @@
 																				<object class="NSMutableArray">
 																					<bool key="EncodedWithXMLCoder">YES</bool>
-																					<reference ref="880775721"/>
-																					<reference ref="17599908"/>
-																					<reference ref="729925139"/>
+																					<reference ref="173485813"/>
+																					<reference ref="375500148"/>
+																					<reference ref="293689974"/>
 																				</object>
 																				<object class="NSMutableArray">
@@ -2481,7 +2498,7 @@
 																				<object class="NSMutableArray">
 																					<bool key="EncodedWithXMLCoder">YES</bool>
-																					<reference ref="539965909"/>
-																					<reference ref="635329650"/>
-																					<reference ref="773622241"/>
+																					<reference ref="998086679"/>
+																					<reference ref="699004508"/>
+																					<reference ref="30477181"/>
 																				</object>
 																				<object class="NSMutableArray">
@@ -2504,7 +2521,7 @@
 													<object class="NSMutableArray" key="NSRuleEditorSlices">
 														<bool key="EncodedWithXMLCoder">YES</bool>
-														<reference ref="363486199"/>
-														<reference ref="1018513936"/>
-														<reference ref="215802558"/>
+														<reference ref="156337374"/>
+														<reference ref="936953994"/>
+														<reference ref="56028161"/>
 													</object>
 													<object class="NSArray" key="NSPredicateTemplates">
@@ -2519,4 +2536,5 @@
 											<string key="NSFrame">{{1, 1}, {771, 25}}</string>
 											<reference key="NSSuperview" ref="815512319"/>
+											<reference key="NSWindow"/>
 											<reference key="NSNextKeyView" ref="872100568"/>
 											<reference key="NSDocView" ref="872100568"/>
@@ -2532,4 +2550,5 @@
 											<string key="NSFrame">{{-100, -100}, {15, 50}}</string>
 											<reference key="NSSuperview" ref="815512319"/>
+											<reference key="NSWindow"/>
 											<bool key="NSEnabled">YES</bool>
 											<reference key="NSTarget" ref="815512319"/>
@@ -2543,4 +2562,5 @@
 											<string key="NSFrame">{{-100, -100}, {360, 15}}</string>
 											<reference key="NSSuperview" ref="815512319"/>
+											<reference key="NSWindow"/>
 											<int key="NSsFlags">1</int>
 											<reference key="NSTarget" ref="815512319"/>
@@ -2550,4 +2570,5 @@
 									<string key="NSFrame">{{0, 397}, {773, 27}}</string>
 									<reference key="NSSuperview" ref="169664854"/>
+									<reference key="NSWindow"/>
 									<reference key="NSNextKeyView" ref="646625812"/>
 									<int key="NSsFlags">66</int>
@@ -2571,4 +2592,5 @@
 													<string key="NSFrameSize">{756, 366}</string>
 													<reference key="NSSuperview" ref="221116208"/>
+													<reference key="NSWindow"/>
 													<bool key="NSEnabled">YES</bool>
 													<object class="NSTableHeaderView" key="NSHeaderView" id="563815802">
@@ -2577,4 +2599,5 @@
 														<string key="NSFrameSize">{756, 17}</string>
 														<reference key="NSSuperview" ref="260654782"/>
+														<reference key="NSWindow"/>
 														<reference key="NSTableView" ref="199649408"/>
 													</object>
@@ -2584,4 +2607,5 @@
 														<string key="NSFrame">{{757, 0}, {16, 17}}</string>
 														<reference key="NSSuperview" ref="520202466"/>
+														<reference key="NSWindow"/>
 													</object>
 													<object class="NSMutableArray" key="NSTableColumns">
@@ -2738,4 +2762,5 @@
 											<string key="NSFrame">{{1, 17}, {756, 366}}</string>
 											<reference key="NSSuperview" ref="520202466"/>
+											<reference key="NSWindow"/>
 											<reference key="NSNextKeyView" ref="199649408"/>
 											<reference key="NSDocView" ref="199649408"/>
@@ -2748,4 +2773,5 @@
 											<string key="NSFrame">{{757, 17}, {15, 366}}</string>
 											<reference key="NSSuperview" ref="520202466"/>
+											<reference key="NSWindow"/>
 											<reference key="NSTarget" ref="520202466"/>
 											<string key="NSAction">_doScroller:</string>
@@ -2757,4 +2783,5 @@
 											<string key="NSFrame">{{1, 383}, {756, 15}}</string>
 											<reference key="NSSuperview" ref="520202466"/>
+											<reference key="NSWindow"/>
 											<int key="NSsFlags">1</int>
 											<reference key="NSTarget" ref="520202466"/>
@@ -2771,4 +2798,5 @@
 											<string key="NSFrame">{{1, 0}, {756, 17}}</string>
 											<reference key="NSSuperview" ref="520202466"/>
+											<reference key="NSWindow"/>
 											<reference key="NSNextKeyView" ref="563815802"/>
 											<reference key="NSDocView" ref="563815802"/>
@@ -2780,4 +2808,5 @@
 									<string key="NSFrameSize">{773, 399}</string>
 									<reference key="NSSuperview" ref="169664854"/>
+									<reference key="NSWindow"/>
 									<reference key="NSNextKeyView" ref="221116208"/>
 									<int key="NSsFlags">50</int>
@@ -2795,4 +2824,5 @@
 									<string key="NSFrame">{{370, 183}, {32, 32}}</string>
 									<reference key="NSSuperview" ref="169664854"/>
+									<reference key="NSWindow"/>
 									<int key="NSpiFlags">20490</int>
 									<double key="NSMinValue">16</double>
@@ -2802,4 +2832,5 @@
 							<string key="NSFrame">{{0, 28}, {773, 424}}</string>
 							<reference key="NSSuperview" ref="439893737"/>
+							<reference key="NSWindow"/>
 							<string key="NSClassName">NSView</string>
 						</object>
@@ -2810,4 +2841,5 @@
 							<string key="NSFrame">{{6, 9}, {63, 12}}</string>
 							<reference key="NSSuperview" ref="439893737"/>
+							<reference key="NSWindow"/>
 							<int key="NSpiFlags">24842</int>
 							<double key="NSMaxValue">100</double>
@@ -2818,4 +2850,5 @@
 							<string key="NSFrame">{{73, 7}, {231, 17}}</string>
 							<reference key="NSSuperview" ref="439893737"/>
+							<reference key="NSWindow"/>
 							<bool key="NSEnabled">YES</bool>
 							<object class="NSTextFieldCell" key="NSCell" id="937120685">
@@ -2837,4 +2870,5 @@
 					<string key="NSFrameSize">{773, 452}</string>
 					<reference key="NSSuperview"/>
+					<reference key="NSWindow"/>
 				</object>
 				<string key="NSScreenRect">{{0, 0}, {1680, 1028}}</string>
@@ -2870,4 +2904,5 @@
 											<string key="NSFrameSize">{246, 331}</string>
 											<reference key="NSSuperview" ref="340647127"/>
+											<reference key="NSWindow"/>
 											<bool key="NSEnabled">YES</bool>
 											<object class="_NSCornerView" key="NSCornerView">
@@ -2977,4 +3012,5 @@
 									<string key="NSFrame">{{1, 1}, {246, 331}}</string>
 									<reference key="NSSuperview" ref="199390391"/>
+									<reference key="NSWindow"/>
 									<reference key="NSNextKeyView" ref="238622922"/>
 									<reference key="NSDocView" ref="238622922"/>
@@ -2987,4 +3023,5 @@
 									<string key="NSFrame">{{247, 1}, {15, 331}}</string>
 									<reference key="NSSuperview" ref="199390391"/>
+									<reference key="NSWindow"/>
 									<reference key="NSTarget" ref="199390391"/>
 									<string key="NSAction">_doScroller:</string>
@@ -2996,4 +3033,5 @@
 									<string key="NSFrame">{{1, 332}, {246, 15}}</string>
 									<reference key="NSSuperview" ref="199390391"/>
+									<reference key="NSWindow"/>
 									<int key="NSsFlags">1</int>
 									<reference key="NSTarget" ref="199390391"/>
@@ -3004,4 +3042,5 @@
 							<string key="NSFrame">{{6, 26}, {263, 348}}</string>
 							<reference key="NSSuperview" ref="187671130"/>
+							<reference key="NSWindow"/>
 							<reference key="NSNextKeyView" ref="340647127"/>
 							<int key="NSsFlags">50</int>
@@ -3014,4 +3053,5 @@
 					<string key="NSFrameSize">{276, 378}</string>
 					<reference key="NSSuperview"/>
+					<reference key="NSWindow"/>
 				</object>
 				<string key="NSScreenRect">{{0, 0}, {1280, 778}}</string>
@@ -3423,5 +3463,5 @@
 										<reference key="NSNextResponder" ref="874476791"/>
 										<int key="NSvFlags">256</int>
-										<string key="NSFrameSize">{238, 418}</string>
+										<string key="NSFrameSize">{254, 418}</string>
 										<reference key="NSSuperview" ref="874476791"/>
 										<bool key="NSEnabled">YES</bool>
@@ -3429,5 +3469,5 @@
 											<reference key="NSNextResponder" ref="171583958"/>
 											<int key="NSvFlags">256</int>
-											<string key="NSFrameSize">{238, 17}</string>
+											<string key="NSFrameSize">{254, 17}</string>
 											<reference key="NSSuperview" ref="171583958"/>
 											<reference key="NSTableView" ref="7154443"/>
@@ -3465,5 +3505,5 @@
 													<reference key="NSTextColor" ref="475656758"/>
 												</object>
-												<int key="NSResizingMask">3</int>
+												<int key="NSResizingMask">1</int>
 												<bool key="NSIsResizeable">YES</bool>
 												<bool key="NSIsEditable">YES</bool>
@@ -3471,5 +3511,5 @@
 											</object>
 											<object class="NSTableColumn" id="315945499">
-												<double key="NSWidth">171</double>
+												<double key="NSWidth">120</double>
 												<double key="NSMinWidth">40</double>
 												<double key="NSMaxWidth">1000</double>
@@ -3491,4 +3531,30 @@
 													<reference key="NSTextColor" ref="475656758"/>
 												</object>
+												<int key="NSResizingMask">1</int>
+												<bool key="NSIsResizeable">YES</bool>
+												<bool key="NSIsEditable">YES</bool>
+												<reference key="NSTableView" ref="7154443"/>
+											</object>
+											<object class="NSTableColumn" id="112554963">
+												<double key="NSWidth">64</double>
+												<double key="NSMinWidth">10</double>
+												<double key="NSMaxWidth">3.4028234663852886e+38</double>
+												<object class="NSTableHeaderCell" key="NSHeaderCell">
+													<int key="NSCellFlags">75628096</int>
+													<int key="NSCellFlags2">2048</int>
+													<string key="NSContents"/>
+													<reference key="NSSupport" ref="26"/>
+													<reference key="NSBackgroundColor" ref="934732725"/>
+													<reference key="NSTextColor" ref="67059057"/>
+												</object>
+												<object class="NSTextFieldCell" key="NSDataCell" id="647470268">
+													<int key="NSCellFlags">337772096</int>
+													<int key="NSCellFlags2">2048</int>
+													<string key="NSContents">Text Cell</string>
+													<reference key="NSSupport" ref="782475540"/>
+													<reference key="NSControlView" ref="7154443"/>
+													<reference key="NSBackgroundColor" ref="800202432"/>
+													<reference key="NSTextColor" ref="475656758"/>
+												</object>
 												<int key="NSResizingMask">3</int>
 												<bool key="NSIsResizeable">YES</bool>
@@ -3502,5 +3568,5 @@
 										<reference key="NSGridColor" ref="391761051"/>
 										<double key="NSRowHeight">17</double>
-										<int key="NSTvFlags">-700448768</int>
+										<int key="NSTvFlags">373293056</int>
 										<reference key="NSDelegate"/>
 										<reference key="NSDataSource"/>
@@ -3534,4 +3600,5 @@
 								<string key="NSFrame">{{-100, -100}, {224, 15}}</string>
 								<reference key="NSSuperview" ref="271863607"/>
+								<bool key="NSEnabled">YES</bool>
 								<int key="NSsFlags">1</int>
 								<reference key="NSTarget" ref="271863607"/>
@@ -3558,5 +3625,5 @@
 						<reference key="NSSuperview" ref="610590059"/>
 						<reference key="NSNextKeyView" ref="874476791"/>
-						<int key="NSsFlags">530</int>
+						<int key="NSsFlags">658</int>
 						<reference key="NSVScroller" ref="24793711"/>
 						<reference key="NSHScroller" ref="570962116"/>
@@ -4582,4 +4649,36 @@
 					<int key="connectionID">873</int>
 				</object>
+				<object class="IBConnectionRecord">
+					<object class="IBBindingConnection" key="connection">
+						<string key="label">value: arrangedObjects.operation</string>
+						<reference key="source" ref="1036951787"/>
+						<reference key="destination" ref="194540380"/>
+						<object class="NSNibBindingConnector" key="connector">
+							<reference key="NSSource" ref="1036951787"/>
+							<reference key="NSDestination" ref="194540380"/>
+							<string key="NSLabel">value: arrangedObjects.operation</string>
+							<string key="NSBinding">value</string>
+							<string key="NSKeyPath">arrangedObjects.operation</string>
+							<int key="NSNibBindingConnectorVersion">2</int>
+						</object>
+					</object>
+					<int key="connectionID">880</int>
+				</object>
+				<object class="IBConnectionRecord">
+					<object class="IBBindingConnection" key="connection">
+						<string key="label">value: arrangedObjects.port</string>
+						<reference key="source" ref="315945499"/>
+						<reference key="destination" ref="194540380"/>
+						<object class="NSNibBindingConnector" key="connector">
+							<reference key="NSSource" ref="315945499"/>
+							<reference key="NSDestination" ref="194540380"/>
+							<string key="NSLabel">value: arrangedObjects.port</string>
+							<string key="NSBinding">value</string>
+							<string key="NSKeyPath">arrangedObjects.port</string>
+							<int key="NSNibBindingConnectorVersion">2</int>
+						</object>
+					</object>
+					<int key="connectionID">881</int>
+				</object>
 			</object>
 			<object class="IBMutableOrderedSet" key="objectRecords">
@@ -6074,4 +6173,5 @@
 							<reference ref="1036951787"/>
 							<reference ref="315945499"/>
+							<reference ref="112554963"/>
 						</object>
 						<reference key="parent" ref="271863607"/>
@@ -6182,4 +6282,18 @@
 						<reference key="object" ref="412817228"/>
 						<reference key="parent" ref="452370589"/>
+					</object>
+					<object class="IBObjectRecord">
+						<int key="objectID">885</int>
+						<reference key="object" ref="112554963"/>
+						<object class="NSMutableArray" key="children">
+							<bool key="EncodedWithXMLCoder">YES</bool>
+							<reference ref="647470268"/>
+						</object>
+						<reference key="parent" ref="7154443"/>
+					</object>
+					<object class="IBObjectRecord">
+						<int key="objectID">886</int>
+						<reference key="object" ref="647470268"/>
+						<reference key="parent" ref="112554963"/>
 					</object>
 				</object>
@@ -6663,8 +6777,8 @@
 					<string>com.apple.InterfaceBuilder.CocoaPlugin</string>
 					<integer value="1"/>
-					<string>{{343, 210}, {773, 452}}</string>
+					<string>{{543, 140}, {773, 452}}</string>
 					<string>com.apple.InterfaceBuilder.CocoaPlugin</string>
 					<boolean value="NO"/>
-					<string>{{343, 210}, {773, 452}}</string>
+					<string>{{543, 140}, {773, 452}}</string>
 					<integer value="1"/>
 					<string>{{33, 99}, {480, 360}}</string>
@@ -6706,7 +6820,7 @@
 					<string>com.apple.InterfaceBuilder.CocoaPlugin</string>
 					<string>com.apple.InterfaceBuilder.CocoaPlugin</string>
-					<string>{{686, 79}, {276, 378}}</string>
-					<string>com.apple.InterfaceBuilder.CocoaPlugin</string>
-					<string>{{686, 79}, {276, 378}}</string>
+					<string>{{598, 192}, {276, 378}}</string>
+					<string>com.apple.InterfaceBuilder.CocoaPlugin</string>
+					<string>{{598, 192}, {276, 378}}</string>
 					<boolean value="NO"/>
 					<string>com.apple.InterfaceBuilder.CocoaPlugin</string>
@@ -6837,5 +6951,5 @@
 					<string>com.apple.InterfaceBuilder.CocoaPlugin</string>
 					<string>com.apple.InterfaceBuilder.CocoaPlugin</string>
-					<string>{{354, 170}, {240, 468}}</string>
+					<string>{{727, 248}, {240, 468}}</string>
 					<string>com.apple.InterfaceBuilder.CocoaPlugin</string>
 					<string>com.apple.InterfaceBuilder.CocoaPlugin</string>
@@ -6872,5 +6986,5 @@
 			</object>
 			<nil key="sourceID"/>
-			<int key="maxID">873</int>
+			<int key="maxID">886</int>
 		</object>
 		<object class="IBClassDescriber" key="IBDocument.Classes">
Index: branches/gsoc10-gui/Pallet/MPActionsController.h
===================================================================
--- branches/gsoc10-gui/Pallet/MPActionsController.h	(revision 68443)
+++ branches/gsoc10-gui/Pallet/MPActionsController.h	(revision 68787)
@@ -21,4 +21,5 @@
 	IBOutlet NSButton *startQueueButton;
     IBOutlet NSArrayController *queue;
+    IBOutlet PortsTableController *queueController;
 }
 
@@ -32,4 +33,6 @@
 - (IBAction)cancel:(id)sender;
 
+- (void) queueOperation: (NSString*) operation andPort: (NSString*) port;
+
 -(IBAction) startQueue:(id) sender;
 
Index: branches/gsoc10-gui/Pallet/MPActionsController.m
===================================================================
--- branches/gsoc10-gui/Pallet/MPActionsController.m	(revision 68443)
+++ branches/gsoc10-gui/Pallet/MPActionsController.m	(revision 68787)
@@ -24,6 +24,8 @@
     NSArray *selectedPorts = [ports selectedObjects];
     for (id port in selectedPorts) {
-        [[MPActionLauncher sharedInstance]
-            performSelectorInBackground:@selector(installPort:) withObject:port];
+		[self queueOperation:@"install" andPort:[port name]];
+		NSLog(@"%@",[port name]);
+        //[[MPActionLauncher sharedInstance]
+        //    performSelectorInBackground:@selector(installPort:) withObject:port];
     }
 	NSLog(@"Installation Completed");
@@ -33,6 +35,10 @@
     NSArray *selectedPorts = [ports selectedObjects];
     for (id port in selectedPorts) {
-        [[MPActionLauncher sharedInstance]
+ 		[self queueOperation:@"uninstall" andPort:[port name]];
+		NSLog(@"%@",[port name]);
+		/*
+       [[MPActionLauncher sharedInstance]
             performSelectorInBackground:@selector(uninstallPort:) withObject:port];
+		 */
     }
 }
@@ -41,17 +47,27 @@
     NSArray *selectedPorts = [ports selectedObjects];
     for (id port in selectedPorts) {
+		[self queueOperation:@"upgrade" andPort:[port name]];
+		NSLog(@"%@",[port name]);
+		/*
         [[MPActionLauncher sharedInstance]
             performSelectorInBackground:@selector(upgradePort:) withObject:port];
+		 */
     }
 }
 
 - (IBAction)sync:(id)sender {
+	[self queueOperation:@"sync" andPort:@"sync"];
+	/*
     [[MPActionLauncher sharedInstance]
         performSelectorInBackground:@selector(sync) withObject:nil];
+	 */
 }
 
 - (IBAction)selfupdate:(id)sender {
+	[self queueOperation:@"selfupdate" andPort:@"selfupdate"];
+	/*
     [[MPActionLauncher sharedInstance]
         performSelectorInBackground:@selector(selfupdate) withObject:nil];
+	 */
 }
 
@@ -98,5 +114,42 @@
 -(void) startQueue:(id) sender
 {
-	NSLog(@"Starting Queue Operations");
+	//[queue selectNext:nil];
+	NSLog(@"Starting Queue");
+	NSUInteger index;
+	index = [queue selectionIndex];
+	NSLog(@"Index before: %u", index);
+	NSUInteger i;
+	[queue setSelectionIndex: 0];
+	for(i=0; i<=index; i++)
+	{
+		//We select each object from the array
+		[queue setSelectionIndex:i];
+		//We sleep the process for debugging puproses
+		sleep(3);
+		//We take the array of selected objects
+		NSArray *wtf = [queue selectedObjects];
+		//We then take the dictionary
+		NSMutableDictionary *dict = [NSMutableDictionary dictionaryWithDictionary:[wtf objectAtIndex:0]];
+		//And we print the operations
+		NSLog(@"Port %@ Operation %@",[dict objectForKey:@"port"], [dict objectForKey:@"operation"]);
+		
+	}
+	[queue setSelectionIndex:index];
+	//[queue remove:nil];
+
+	
+	//index = [queue selectionIndex];
+	//NSLog(@"Index after: %u", index);
+	//NSLog(@"Starting Queue Operations");
+}
+
+-(void) queueOperation:(NSString*)operation andPort:(NSString*)port
+{
+	NSLog(@"Queueing our Operation");
+	//NSMutableDictionary *tempDict=[[NSMutableDictionary alloc] initWithObjectsAndKeys:@"wtf", @"operation", @"le_port", @"port", nil];
+	[queue addObject:[NSMutableDictionary dictionaryWithObjectsAndKeys:operation, @"operation", port, @"port",nil]];
+	//[queue addObject: tempDict];
+	//[queue retain];
+	
 }
 
Index: branches/gsoc10-gui/Pallet/PortsTableController.h
===================================================================
--- branches/gsoc10-gui/Pallet/PortsTableController.h	(revision 68443)
+++ branches/gsoc10-gui/Pallet/PortsTableController.h	(revision 68787)
@@ -60,4 +60,6 @@
 - (IBAction)hidePredicateEditor:(id)sender;
 
+
+//Drawer methods
 - (IBAction)open:(id)sender;
 - (IBAction)close:(id)sender;
